import { prisma } from "@/module/_global";
import _ from "lodash";
import { NextResponse } from "next/server";


// GET ALL DATA DIVISI == LIST DATA DIVISI
export async function GET(request: Request) {
   try {
      const { searchParams } = new URL(request.url);
      const idVillage = searchParams.get("desa");
      const idGroup = searchParams.get("group");
      const name = searchParams.get('search');
      const page = searchParams.get('page');
      const active = searchParams.get("active");
      const get = searchParams.get('get')

      let getFix = 10;
      if (get == null || get == undefined || get == "" || _.isNaN(Number(get))) {
         getFix = 10;
      } else {
         getFix = Number(get);
      }

      const dataSkip = page == null || page == undefined ? 0 : Number(page) * getFix - getFix;

      let kondisi: any = {
         isActive: active == 'false' ? false : true,
         idVillage: String(idVillage),
         name: {
            contains: (name == undefined || name == "null") ? "" : name,
            mode: "insensitive"
         }
      }

      if (idGroup != "null" && idGroup != undefined && idGroup != "") {
         kondisi = {
            ...kondisi,
            idGroup: String(idGroup)
         }
      }


      const data = await prisma.division.findMany({
         skip: dataSkip,
         take: getFix,
         where: kondisi,
         select: {
            id: true,
            name: true,
            desc: true,
            idGroup: true,
            Group: {
               select: {
                  name: true
               }
            },
            DivisionMember: {
               where: {
                  isActive: true
               },
               select: {
                  idUser: true
               }
            }
         },
         orderBy: {
            createdAt: 'desc'
         }
      });

      const allData = data.map((v: any) => ({
         ..._.omit(v, ["DivisionMember", "Group"]),
         group: v.Group.name,
         jumlahMember: v.DivisionMember.length,
      }))


      return NextResponse.json({ success: true, message: "Berhasil mendapatkan divisi", data: allData }, { status: 200 });

   } catch (error) {
      console.error(error);
      return NextResponse.json({ success: false, message: "Gagal mendapatkan divisi, coba lagi nanti (error: 500)", reason: (error as Error).message, }, { status: 500 });
   }
}